do
  local _parent_0 = Common
  local _base_0 = {
    update = function(self, dt)
      _parent_0.update(self, dt)
      for k, v in pairs(self.message) do
        v:update(dt)
      end
    end,
    draw = function(self)
      do
        local _with_0 = love.graphics
        _with_0.setColor(0, 0, 0, self.blackAlpha)
        _with_0.rectangle('fill', 0, 0, WIDTH, HEIGHT)
      end
      for k, v in pairs(self.message) do
        v:draw()
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self)
      _parent_0.__init(self)
      self.blackAlpha = 255
      self.message = { }
      game.signal.register('game-countoff', function()
        self.tween:to(self, .5, {
          blackAlpha = 0
        })
        local message = UIGroup(WIDTH / 2, HEIGHT / 2 + HEIGHT)
        do
          message:addText(UIText('Round ' .. game.rounds, font.big, 0, 0))
          message:addText(UIText(game.p1score .. ' - ' .. game.p2score, font.medium, 0, HEIGHT * .1))
          message:addText(UIText('Go!', font.big, 0, HEIGHT))
          message.tween:to(message, 0.5, {
            y = HEIGHT / 2
          }):ease('backinout')
          message.timer.add(1, function()
            message.tween:to(message, 0.5, {
              y = HEIGHT / 2 - HEIGHT
            }):ease('backinout')
            return message.timer.add(1, function()
              return message.tween:to(message, 0.5, {
                y = HEIGHT / 2 - 2 * HEIGHT
              }):ease('backinout')
            end)
          end)
        end
        return table.insert(self.message, message)
      end)
      game.signal.register('round-end', function(playerNum)
        self.timer.add(1.5, function()
          return self.tween:to(self, .5, {
            blackAlpha = 255
          })
        end)
        local message = UIGroup(WIDTH / 2, HEIGHT / 2)
        do
          message:addText(UIText('Player ' .. playerNum .. ' wins!', font.big, 0, HEIGHT))
          message.tween:to(message, 0.5, {
            y = HEIGHT / 2 - HEIGHT
          }):ease('backinout')
          message.timer.add(1.5, function()
            return message.tween:to(message, 0.5, {
              y = HEIGHT / 2 - 2 * HEIGHT
            }):ease('backinout')
          end)
        end
        return table.insert(self.message, message)
      end)
      return game.signal.register('match-end', function(playerNum)
        self.timer.add(1.5, function()
          return self.tween:to(self, .5, {
            blackAlpha = 255
          })
        end)
        local message = UIGroup(WIDTH / 2, HEIGHT / 2)
        do
          message:addText(UIText('Champion:', font.medium, 0, HEIGHT * .95))
          message:addText(UIText('Player ' .. playerNum, font.big, 0, HEIGHT * 1.05))
          message.tween:to(message, 0.5, {
            y = HEIGHT / 2 - HEIGHT
          }):ease('backinout')
          message.timer.add(1.5, function()
            return message.tween:to(message, 0.5, {
              y = HEIGHT / 2 - 2 * HEIGHT
            }):ease('backinout')
          end)
        end
        return table.insert(self.message, message)
      end)
    end,
    __base = _base_0,
    __name = "Hud",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Hud = _class_0
end
