do
  local _base_0 = {
    update = function(self, dt)
      if self.enabled then
        for i, v in ipairs(self.controls) do
          do
            local _with_0 = love.keyboard
            if _with_0.isDown(v.left) then
              game.signal.emit('player-walk', i, dt, -1)
            elseif _with_0.isDown(v.right) then
              game.signal.emit('player-walk', i, dt, 1)
            else
              game.signal.emit('player-walk', i, dt, 0)
            end
          end
        end
      end
    end,
    keypressed = function(self, key)
      if key == 'escape' then
        gamestate.push(pause)
      end
      if self.enabled then
        for i, v in ipairs(self.controls) do
          if key == v.jump then
            game.signal.emit('player-jump', i)
          elseif key == v.dive then
            game.signal.emit('player-dive', i)
          end
        end
      end
    end,
    keyreleased = function(self, key)
      if self.enabled then
        for i, v in ipairs(self.controls) do
          if key == v.jump then
            game.signal.emit('player-end-jump', i)
          elseif key == v.dive then
            game.signal.emit('player-end-dive', i)
          end
        end
      end
    end
  }
  _base_0.__index = _base_0
  local _class_0 = setmetatable({
    __init = function(self)
      self.controls = { }
      self.controls[1] = {
        left = 'left',
        right = 'right',
        jump = 'up',
        dive = 'down'
      }
      self.controls[2] = {
        left = 'a',
        right = 'd',
        jump = 'w',
        dive = 's'
      }
      self.enabled = false
      game.signal.register('game-countoff', function()
        self.enabled = false
      end)
      return game.signal.register('game-start', function()
        self.enabled = true
      end)
    end,
    __base = _base_0,
    __name = "InputManager"
  }, {
    __index = _base_0,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  InputManager = _class_0
end
