do
  local _parent_0 = Common
  local _base_0 = {
    update = function(self, dt)
      local _list_0 = self.world:getItems()
      for _index_0 = 1, #_list_0 do
        local item = _list_0[_index_0]
        item:update(dt)
      end
    end,
    clearSignals = function(self)
      local _list_0 = self.world:getItems()
      for _index_0 = 1, #_list_0 do
        local item = _list_0[_index_0]
        item:clearSignals()
      end
    end,
    draw = function(self)
      do
        local _with_0 = love.graphics
        _with_0.setColor(150, 150, 150, 255)
        _with_0.setColor(255, 255, 255, 255)
        if self.environment then
          _with_0.draw(self.environment)
        end
      end
      local items = self.world:getItems()
      table.sort(items, function(a, b)
        return a.drawDepth < b.drawDepth
      end)
      for _index_0 = 1, #items do
        local item = items[_index_0]
        item:draw()
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, levelname)
      self.world = bump.newWorld()
      self.player = { }
      for line in love.filesystem.lines('level/' .. levelname .. '.oel') do
        if line:find('<rect') then
          local x = tonumber(line:match('x="(.-)"'))
          local y = tonumber(line:match('y="(.-)"'))
          local w = tonumber(line:match('w="(.-)"'))
          local h = tonumber(line:match('h="(.-)"'))
          Wall(self.world, x, y, w, h)
        elseif line:find('<Player') then
          local x = tonumber(line:match('x="(.-)"'))
          local y = tonumber(line:match('y="(.-)"'))
          table.insert(self.player, Player(self.world, x, y, #self.player + 1))
        elseif line:find('<Bubble') then
          local x = tonumber(line:match('x="(.-)"'))
          local y = tonumber(line:match('y="(.-)"'))
          self.bubble = Bubble(self.world, x, y)
        end
      end
      if love.filesystem.exists('level/' .. levelname .. '.png') then
        self.environment = love.graphics.newImage('level/' .. levelname .. '.png')
      end
    end,
    __base = _base_0,
    __name = "Map",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Map = _class_0
end
