do
  local _parent_0 = Physical
  local _base_0 = {
    update = function(self, dt)
      _parent_0.update(self, dt)
      if self.enabled and self.canSwitchPlayers then
        local _list_0 = self.world:getItems()
        for _index_0 = 1, #_list_0 do
          local item = _list_0[_index_0]
          if item.__class == Player and self.following ~= item then
            local otherX, otherY = item:getCenter()
            if lume.distance(self.x, self.y, otherX, otherY) < self.radius then
              if self.following then
                self.following.hasBubble = false
                self.following.particle.bubble:stop()
              end
              self.following = item
              self.following.hasBubble = true
              self.following.particle.bubble:start()
              self.moveSpeed = .1
              self.goalRadius = 20
              self.alpha = 255
              self.brightness = 255
              self.canSwitchPlayers = false
              self.timer.add(1, function()
                self.canSwitchPlayers = true
              end)
              sound.bubbleGet:play()
              break
            end
          end
        end
      end
      if self.following then
        self.goalX, self.goalY = self.following:getCenter()
        if self.enabled then
          self.following.time = self.following.time + dt
          self.goalRadius = self.goalRadius + ((self.growthSpeed + 5 * self.growthSpeed * (self.following.time / 60)) * dt)
        end
      end
      self.moveSpeed = lume.lerp(self.moveSpeed, .5, .01)
      if lume.distance(self.x, self.y, self.goalX, self.goalY) > 100 then
        self.x = self.goalX
        self.y = self.goalY
      else
        self.x = lume.lerp(self.x, self.goalX, self.moveSpeed)
        self.y = lume.lerp(self.y, self.goalY, self.moveSpeed)
      end
      self.radius = lume.lerp(self.radius, self.goalRadius, .1)
      self.alpha = lume.lerp(self.alpha, 100, .03)
      self.brightness = lume.lerp(self.brightness, 0, .01)
    end,
    draw = function(self)
      do
        local _with_0 = love.graphics
        local x, y, r = math.floor(self.x), math.floor(self.y), math.floor(self.radius)
        _with_0.setColor(100, 100, 255, self.alpha)
        _with_0.circle('fill', x, y, r, 100)
        _with_0.setLineWidth(2)
        _with_0.setLineStyle('rough')
        _with_0.setColor(255, 255, 255, 255)
        _with_0.circle('line', x, y, r - 2, 100)
        _with_0.setColor(0, 0, 0, 255)
        _with_0.circle('line', x, y, r, 100)
        return _with_0
      end
    end,
    drawDebug = function(self) end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, world, x, y)
      self.x, self.y = x, y
      _parent_0.__init(self, world, 0, 0, 512, 288)
      self.enabled = true
      self.goalX = self.x
      self.goalY = self.y
      self.moveSpeed = .5
      self.radius = 20
      self.goalRadius = self.radius
      self.growthSpeed = 2
      self.following = false
      self.canSwitchPlayers = true
      self.alpha = 150
      self.brightness = 0
      self.drawDepth = 50
      return game.signal.register('player-win', function()
        self.enabled = false
      end)
    end,
    __base = _base_0,
    __name = "Bubble",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Bubble = _class_0
end
