do
  local _parent_0 = MenuOption
  local _base_0 = {
    startHighlighted = function(self)
      self.color = {
        255,
        255,
        255,
        255
      }
    end,
    highlight = function(self)
      self.color = {
        255,
        255,
        255,
        255
      }
    end,
    unhighlight = function(self)
      self.color = {
        150,
        150,
        150,
        255
      }
    end,
    previous = function(self)
      self.selected = self.selected - 1
      if self.selected == 0 then
        self.selected = #self.maps
      end
    end,
    next = function(self)
      self.selected = self.selected + 1
      if self.selected > #self.maps then
        self.selected = 1
      end
    end,
    select = function(self)
      return self.timer.add(0.5, function()
        return gamestate.switch(game, self.maps[self.selected].name)
      end)
    end,
    update = function(self, dt)
      self.timer.update(dt)
      self.x = WIDTH * self.scale * (self.selected - 1)
      self.goalX = lume.lerp(self.goalX, self.x, .15)
    end,
    draw = function(self)
      local cx, cy = WIDTH / 2, HEIGHT / 2
      local pw, ph = WIDTH * self.scale, HEIGHT * self.scale
      self.canvas:clear(0, 0, 0, 255)
      self.canvas:renderTo(function()
        do
          local _with_0 = love.graphics
          _with_0.setColor(255, 255, 255, 255)
          for i = 1, #self.maps do
            local x = pw * (i - 1) - self.goalX
            _with_0.draw(self.maps[i].image, lume.round(x), 0, 0, self.scale, self.scale)
          end
          return _with_0
        end
      end)
      do
        local _with_0 = love.graphics
        _with_0.setColor(self.color)
        _with_0.setLineWidth(4)
        _with_0.rectangle('line', cx - pw / 2, cy - ph / 2, pw, ph)
        _with_0.draw(self.canvas, cx - pw / 2, cy - ph / 2)
        return _with_0
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, select)
      self.select = select
      self.timer = timer.new()
      self.maps = { }
      local _list_0 = love.filesystem.getDirectoryItems('level')
      for _index_0 = 1, #_list_0 do
        local file = _list_0[_index_0]
        if file:find('.oel') then
          local name = file:match('(.*).oel')
          print(file, name)
          table.insert(self.maps, {
            name = name,
            image = love.graphics.newImage('level/' .. name .. '.png')
          })
        end
      end
      self.scale = .75
      self.selected = 1
      self.x = 0
      self.goalX = 0
      self.canvas = love.graphics.newCanvas(WIDTH * self.scale, HEIGHT * self.scale)
    end,
    __base = _base_0,
    __name = "MapSelector",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  MapSelector = _class_0
end
