do
  local _base_0 = {
    addOption = function(self, option)
      table.insert(self.option, option)
      if #self.option == 1 then
        return self.option[#self.option]:startHighlighted()
      end
    end,
    next = function(self)
      self.option[self.current]:unhighlight()
      self.current = self.current + 1
      if self.current > #self.option then
        self.current = 1
      end
      return self.option[self.current]:highlight()
    end,
    previous = function(self)
      self.option[self.current]:unhighlight()
      self.current = self.current - 1
      if self.current == 0 then
        self.current = #self.option
      end
      return self.option[self.current]:highlight()
    end,
    secondaryNext = function(self)
      return self.option[self.current]:next()
    end,
    secondaryPrevious = function(self)
      return self.option[self.current]:previous()
    end,
    select = function(self)
      return self.option[self.current]:select()
    end,
    update = function(self, dt)
      for k, v in pairs(self.option) do
        v:update(dt)
      end
    end,
    draw = function(self)
      for k, v in pairs(self.option) do
        v:draw()
      end
    end
  }
  _base_0.__index = _base_0
  local _class_0 = setmetatable({
    __init = function(self)
      self.option = { }
      self.current = 1
    end,
    __base = _base_0,
    __name = "Menu"
  }, {
    __index = _base_0,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  Menu = _class_0
end
do
  local _base_0 = {
    startHighlighted = function(self) end,
    highlight = function(self) end,
    unhighlight = function(self) end,
    next = function(self) end,
    previous = function(self) end,
    update = function(self, dt)
      return self.drawable:update(dt)
    end,
    draw = function(self)
      return self.drawable:draw()
    end
  }
  _base_0.__index = _base_0
  local _class_0 = setmetatable({
    __init = function(self, drawable, select)
      self.drawable, self.select = drawable, select
    end,
    __base = _base_0,
    __name = "MenuOption"
  }, {
    __index = _base_0,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  MenuOption = _class_0
end
do
  local _parent_0 = MenuOption
  local _base_0 = {
    startHighlighted = function(self)
      self.drawable.color = self.highlightColor
    end,
    highlight = function(self)
      self.drawable.color = self.highlightColor
    end,
    unhighlight = function(self)
      self.drawable.color = self.color
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  local _class_0 = setmetatable({
    __init = function(self, text, font, x, y, select)
      self.select = select
      self.drawable = UIText(text, font, x, y)
      self.highlightColor = {
        255,
        255,
        255,
        255
      }
      self.color = {
        150,
        150,
        150,
        255
      }
      self.drawable.color = self.color
    end,
    __base = _base_0,
    __name = "MenuOptionText",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        return _parent_0[name]
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  MenuOptionText = _class_0
end
