mapSelect = {
  enter = function(self, previous)
    self.timer = timer.new()
    self.tween = flux.group()
    if previous == game or previous == pause then
      self.blackAlpha = 255
      self.tween:to(self, .5, {
        blackAlpha = 0
      })
    else
      self.blackAlpha = 0
    end
    self.takeInput = true
    self.text = UIText('Select map', font.medium, WIDTH / 2, HEIGHT * .05)
    self.menu = Menu()
    self.menu:addOption(MapSelector())
    self.menu:addOption(MenuOptionText('Back', font.medium, WIDTH / 2, HEIGHT * .925, function(self)
      return gamestate.switch(title)
    end))
    self.canvas = love.graphics.newCanvas(WIDTH, HEIGHT)
    return sound.voiceSelectMap:play()
  end,
  update = function(self, dt)
    self.timer.update(dt)
    self.tween:update(dt)
    return self.menu:update(dt)
  end,
  keypressed = function(self, key)
    if self.takeInput then
      if key == 'up' or key == 'w' then
        self.menu:previous()
        sound.menuBlip:play()
      end
      if key == 'down' or key == 's' then
        self.menu:next()
        sound.menuBlip:play()
      end
      if key == 'left' or key == 'a' then
        self.menu:secondaryPrevious()
        if self.menu.current == 1 then
          sound.menuBlip:play()
        end
      end
      if key == 'right' or key == 'd' then
        self.menu:secondaryNext()
        if self.menu.current == 1 then
          sound.menuBlip:play()
        end
      end
      if key == 'return' then
        sound.menuSelect:play()
        self.menu:select()
        if self.menu.current == 1 then
          self.takeInput = false
          return self.tween:to(self, .5, {
            blackAlpha = 255
          })
        end
      end
    end
  end,
  draw = function(self)
    self.canvas:clear(50, 50, 50, 255)
    self.canvas:renderTo(function()
      self.text:draw()
      self.menu:draw()
      do
        local _with_0 = love.graphics
        _with_0.setColor(0, 0, 0, self.blackAlpha)
        _with_0.rectangle('fill', 0, 0, WIDTH, HEIGHT)
        return _with_0
      end
    end)
    do
      local _with_0 = love.graphics
      _with_0.setColor(255, 255, 255, 255)
      _with_0.draw(self.canvas, 0, 0, 0, _with_0.getHeight() / HEIGHT, _with_0.getHeight() / HEIGHT)
      return _with_0
    end
  end
}
