options = {
  enter = function(self)
    self.titleText = UIText('Options', font.big, WIDTH / 2, HEIGHT * .3)
    self.menu = Menu()
    local text = 'Scale: ' .. option.scale .. 'X'
    self.menu:addOption(MenuOptionText(text, font.medium, WIDTH / 2, HEIGHT / 2, function(self)
      option.scale = option.scale + .5
      if option.scale > 4 then
        option.scale = 1
      end
      if not option.fullscreen then
        return love.window.setMode(WIDTH * option.scale, HEIGHT * option.scale)
      end
    end))
    if option.fullscreen then
      text = 'Fullscreen: On'
    else
      text = 'Fullscreen: Off'
    end
    self.menu:addOption(MenuOptionText(text, font.medium, WIDTH / 2, HEIGHT * .6, function(self)
      option.fullscreen = not option.fullscreen
      if option.fullscreen then
        local width, height = love.window.getDesktopDimensions()
        return love.window.setMode(width, height, {
          fullscreen = true
        })
      else
        return love.window.setMode(WIDTH * option.scale, HEIGHT * option.scale, {
          fullscreen = false
        })
      end
    end))
    self.menu:addOption(MenuOptionText('Back', font.medium, WIDTH / 2, HEIGHT * .7, function(self)
      love.filesystem.write('options', serialize(option))
      return gamestate.switch(title)
    end))
    self.canvas = love.graphics.newCanvas(WIDTH, HEIGHT)
  end,
  keypressed = function(self, key)
    if key == 'up' then
      self.menu:previous()
      sound.menuBlip:play()
    end
    if key == 'down' then
      self.menu:next()
      sound.menuBlip:play()
    end
    if key == 'return' then
      self.menu:select()
      sound.menuSelect:play()
      self.menu.option[1].drawable.text = 'Scale: ' .. option.scale .. 'X'
      if option.fullscreen then
        self.menu.option[2].drawable.text = 'Fullscreen: On'
      else
        self.menu.option[2].drawable.text = 'Fullscreen: Off'
      end
    end
  end,
  draw = function(self)
    self.canvas:clear(0, 0, 0, 255)
    self.canvas:renderTo(function()
      do
        local _with_0 = love.graphics
        _with_0.setColor(50, 50, 50, 255)
        _with_0.rectangle('fill', 0, 0, WIDTH, HEIGHT)
      end
      self.titleText:draw()
      return self.menu:draw()
    end)
    do
      local _with_0 = love.graphics
      _with_0.setColor(255, 255, 255, 255)
      _with_0.draw(self.canvas, 0, 0, 0, _with_0.getHeight() / HEIGHT, _with_0.getHeight() / HEIGHT)
      return _with_0
    end
  end
}
