pause = {
  enter = function(self)
    self.timer = timer.new()
    self.tween = flux.group()
    self.text1 = UIText('Press enter to continue', font.medium, WIDTH / 2, HEIGHT * .45)
    self.text2 = UIText('Press escape to quit', font.medium, WIDTH / 2, HEIGHT * .55)
    self.blackAlpha = 0
    self.takeInput = true
    self.canvas = love.graphics.newCanvas(WIDTH, HEIGHT)
  end,
  update = function(self, dt)
    self.timer.update(dt)
    return self.tween:update(dt)
  end,
  keypressed = function(self, key)
    if self.takeInput then
      if key == 'return' then
        gamestate.pop()
      end
      if key == 'escape' then
        self.takeInput = false
        sound.menuSelect:play()
        self.tween:to(self, 0.5, {
          blackAlpha = 255
        })
        return self.timer.add(0.5, function()
          return gamestate.switch(mapSelect)
        end)
      end
    end
  end,
  draw = function(self)
    do
      local _with_0 = love.graphics
      self.canvas:renderTo(function()
        _with_0.setColor(100, 100, 100, 255)
        _with_0.draw(game.canvas)
        self.text1:draw()
        self.text2:draw()
        _with_0.setColor(0, 0, 0, self.blackAlpha)
        return _with_0.rectangle('fill', 0, 0, WIDTH, HEIGHT)
      end)
      _with_0.setColor(255, 255, 255, 255)
      _with_0.draw(self.canvas, 0, 0, 0, _with_0.getHeight() / HEIGHT, _with_0.getHeight() / HEIGHT)
      return _with_0
    end
  end
}
